#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: create_initial_vps_sample_configs.pl, v1.1.0.5 Sat 29 Mar 2008 02:41:06 AM CET mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.

# This constructor / handler evaluates the performance of the master node and creates
# sample OpenVZ config files in /etc/vz/conf/ which split the resources into several chunks.

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

$cce->connectuds();

# Location of vserver config files (directory - with trailing slash):
$vzcfgdir = '/etc/sysconfig/vz-scripts/';

&calculate_diskspace;

# Create config files:
	system("/bin/rm -f /etc/vz/conf/ve-100_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 1 -f 100_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-100_percent.conf-sample > /etc/vz/conf/ve-100_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-100_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_100_percent . ':' . $vz_100m_percent . '\" >> /etc/vz/conf/ve-100_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-100_percent.conf-sample.bak');	


	system("/bin/rm -f /etc/vz/conf/ve-50_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 2 -f 50_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-50_percent.conf-sample > /etc/vz/conf/ve-50_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-50_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_50_percent . ':' . $vz_50m_percent . '\" >> /etc/vz/conf/ve-50_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-50_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-33_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 3 -f 33_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-33_percent.conf-sample > /etc/vz/conf/ve-33_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-33_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_33_percent . ':' . $vz_33m_percent . '\" >> /etc/vz/conf/ve-33_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-33_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-25_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 4 -f 25_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-25_percent.conf-sample > /etc/vz/conf/ve-25_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-25_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_25_percent . ':' . $vz_25m_percent . '\" >> /etc/vz/conf/ve-25_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-25_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-20_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 5 -f 20_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-20_percent.conf-sample > /etc/vz/conf/ve-20_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-20_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_20_percent . ':' . $vz_20m_percent . '\" >> /etc/vz/conf/ve-20_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-20_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-10_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 10 -f 10_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-10_percent.conf-sample > /etc/vz/conf/ve-10_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-10_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_10_percent . ':' . $vz_10m_percent . '\" >> /etc/vz/conf/ve-10_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-10_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-7_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 15 -f 7_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-7_percent.conf-sample > /etc/vz/conf/ve-7_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-7_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_7_percent . ':' . $vz_7m_percent . '\" >> /etc/vz/conf/ve-7_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-7_percent.conf-sample.bak');	

	system("/bin/rm -f /etc/vz/conf/ve-5_percent.conf-sample");
	system("/usr/sbin/vzsplit -n 20 -f 5_percent > /dev/null 2>&1");
	system('/bin/echo "" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo ONBOOT=\"yes\" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo NUMPROC=\"800:800\" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo QUOTATIME=\"0\" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo DISK_QUOTA=yes >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo QUOTAUGIDLIMIT=\"10000\" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/sed "s@NUMIPTENT=\"200:200\"@NUMIPTENT=\"20000:20000\"@g" /etc/vz/conf/ve-5_percent.conf-sample > /etc/vz/conf/ve-5_percent.conf-sample.bak');
	system('/bin/cat /etc/vz/conf/ve-5_percent.conf-sample.bak | /bin/grep -v ^DISKSPACE > /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/echo DISKSPACE=\"' . $vz_5_percent . ':' . $vz_5m_percent . '\" >> /etc/vz/conf/ve-5_percent.conf-sample');
	system('/bin/rm -f /etc/vz/conf/ve-5_percent.conf-sample.bak');	


# Delete the crappy standard VPS sample config files that come with OpenVZ:
if (-f "/etc/vz/conf/ve-vps.basic.conf-sample") {
	system("/bin/rm -f /etc/vz/conf/ve-vps.basic.conf-sample");
}
if (-f "/etc/vz/conf/ve-light.conf-sample") {
	system("/bin/rm -f /etc/vz/conf/ve-light.conf-sample");
}

sub calculate_diskspace {

    # vzsplit doesn't get the diskspace right, so we do the math ourselves:

    system("/bin/rm -f /tmp/ini_df");
    system("/bin/df /vz > /tmp/ini_df");

    open(G, "/tmp/ini_df");
    while ($line = <G>) {
        chomp($line);
        next if $line =~ /^\s*$/;               # skip blank lines
        if ($line =~ /\/vz/) {
            $matrix_name = 'Diskspace';
            my (@row) = split (/\s+/, $line);
            push (@{$matrix_name}, \@row);
        }
        else {
            my (@row) = split (/\s+/, $line);
            push (@{$matrix_name}, \@row);
        }
	$vz_total =  $Diskspace[$a][1];
	$vz_used =  $Diskspace[$a][2];
	$vz_free =  $Diskspace[$a][3];

        $a++;
    }
    close (G);
    system("/bin/rm -f /tmp/ini_df");

    # In case we don't have something to work with we exit:
    if ((!$vz_total) || ($vz_total == 0)) {
	$cce->bye('FAIL', 'Partition /vz not found! Not creating sample config files!');
	exit(1);
    }

    # Reserve 4 Gig on /vz for system usage:
    $vz_total = $vz_total - 4000000;

    # 100_percent
    $vz_100_percent = int($vz_total);
    $vz_100m_percent = int(($vz_total + ($vz_total/12)));

    # 50_percent
    $vz_50_percent = int($vz_total/2);
    $vz_50m_percent = int(($vz_50_percent + ($vz_50_percent/12)));

    # 33_percent
    $vz_33_percent = int($vz_total/3);
    $vz_33m_percent = int(($vz_33_percent + ($vz_33_percent/12)));

    # 25_percent
    $vz_25_percent = int($vz_total/4);
    $vz_25m_percent = int(($vz_25_percent + ($vz_25_percent/12)));

    # 20_percent
    $vz_20_percent = int($vz_total/5);
    $vz_20m_percent = int(($vz_20_percent + ($vz_20_percent/12)));

    # 10_percent
    $vz_10_percent = int($vz_total/10);
    $vz_10m_percent = int(($vz_10_percent + ($vz_10_percent/12)));

    # 7_percent
    $vz_7_percent = int($vz_total/15);
    $vz_7m_percent = int(($vz_7_percent + ($vz_7_percent/12)));

    # 5_percent
    $vz_5_percent = int($vz_total/20);
    $vz_5m_percent = int(($vz_5_percent + ($vz_5_percent/12)));
}


$cce->bye('SUCCESS');
exit(0);

